
-- ABANDON ALL HOPE AND LOGIC, YE WO ENTERS THIS LAND,
-- FOR HERE BE SPAGHETTI APLENTY.

local GDEFSCORE = 5000
local mapHoles = {}
local playing = 0
local pfinished = -1
local maptimer = 150*TICRATE
local startmaptimer = false
local d = 4
local m = 3

local function golfHandler(player)
	
	if gametype ~= GT_GOLF then return end
	if (player.mo == nil) or (not player.valid) then return end
	
	//Possible fix for simple mode issues
	if not player.finished then
		player.drawangle = player.cmd.angleturn << 16
	end
	
	//Carrying these into the HUD
	player.maptimer = maptimer
	player.startmaptimer = startmaptimer
	
	//Bouncing!
	if player.noBounce then
		player.noBounce = false
	elseif player.prevMomz ~= nil and player.prevMomz < -2*FRACUNIT and player.mo.momz == 0 and player.prevState == S_PLAY_ROLL then
		P_SetObjectMomZ(player.mo, (player.prevMomz*-1)/2)
		player.mo.state = S_PLAY_ROLL
		if P_ThingOnSpecial3DFloor(player.mo) == nil
		or (not P_ThingOnSpecial3DFloor(player.mo).special == 8192) then
			S_StartSoundAtVolume(player.mo, sfx_s25a, 110)
			if player.mo.eflags & MFE_UNDERWATER then
				P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_MEDIUMBUBBLE)
			else
				P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_SPINDUST)
			end
		end
		player.mo.momx = player.prevMomx
		player.mo.momy = player.prevMomy
	end
	
	//Because goo is evil
	if player.mo.flags & MFE_GOOWATER then
		player.noBounce = true
	end
	
	//Giving PF_JUMPED to players so they can use their shields in midair
	if (not P_IsObjectOnGround(player.mo)) and player.mo.state == S_PLAY_ROLL then
		player.pflags = $ | PF_JUMPED
	end
	
	//Initializing putt counter and score reset prevention
	if player.putts == nil then player.putts = 0 end
	if player.fixedScore == nil then player.fixedScore = 0 end
	
	//Controls menu bool, behavior and vanish timer
	if player.cmenu == nil then player.cmenu = false end
	if player.menuint == nil then player.menuint = 285 end
	if player.menutime == nil then player.menutime = 0 end
	if player.ftoss and (player.menuint < 286 or player.menuint >= 320) then 
		S_StartSoundAtVolume(player.mo, sfx_menu1, 255, player)
		player.cmenu = not $
		player.menutime = 0
	end
	if player.cmenu == false and player.menuint < 285 then
		player.menuint = $+4
	elseif player.cmenu == true and player.menuint > 224 then
		player.menuint = $-4
	end
	if player.menutime < TICRATE*45 and player.menuint > 223 then
		player.menutime = $+1
	end
	if player.menutime == TICRATE*45 and player.menuint < 320 then
		player.menuint = $+4
		player.cmenu = false
	end
	
	
	//Bringing the course's number of holes to our HUD
	player.courseHoles = table.getn(mapHoles)
	
	//Making sure you can't drown
	player.powers[pw_underwater] = 1000
	
	//Initializing putt bar speed
	if player.puttspd == nil then player.puttspd = 2 end
	
	//Initializing text crawl player vars
	if player.crawlHalfway == nil then player.crawlHalfway = false end
	if player.crawlTimer == nil then player.crawlTimer = 0 end
	if player.textCrawl == nil then player.textCrawl = 550 end
	
	//Initialize brake limiter
	if (not player.speed) and P_IsObjectOnGround(player.mo) then
		player.brakeready = true
	end
	
	//Initializing putt arrow state
	if not player.arrowstate then player.arrowstate = S_POINT1 end
	
	//Initializing the course hole counter
	if not player.holeCount then player.holeCount = 1 end
		
	//Initializing power bar
	if player.pwrBarPos == nil then player.pwrBarPos = 1 end
	
	//Initializing manual shield power checking
	if not player.usedShield then player.usedShield = false end
	
	//Golf putt bar blinking
	if player.blinktimer then
		player.blinktimer = $-1
	end
	
	//Manual putt bar controls
	if player.puttspd == 0 and player.puttReady then
		if player.manualMove > 0 and player.pwrBarPos <= 80 then
			player.pwrBarPos = $+1
		elseif player.manualMove < 0 and player.pwrBarPos >= 0 then
			player.pwrBarPos = $-1
		end
	end
	
	//Making the text crawl and its colors work properly
	if player.fixedScoring == nil then player.fixedScoring = 0 end
	if player.crawlScore == nil then player.crawlScore = 0 end
	if player.crawlText == nil then player.crawlText = "this is an error" end
	if player.scoreColor == nil then player.scoreColor = 0 end
	if player.stopCrawl == nil then player.stopCrawl = false end
	
	if player.finished and player.textCrawl <= -70 then
		--scoring stuff
		local parScoring = {"Triple bogey +", "Triple bogey", "Double bogey", "Bogey", "Par", "Birdie", "Eagle", "Albatross", "Condor", "Condor -"}
		--Fixed scoring so things don't change midway through crawl
		player.fixedScoring = (player.arrangedpar[player.holeCount] - player.putts) + 5
		--Fixed scoring numbers
		local multiplier = player.arrangedpar[player.holeCount] - player.putts
		if (player.putts == 1) or (player.putts < player.arrangedpar[player.holeCount]-10) then
			player.crawlScore = (GDEFSCORE*2) + player.rings*10
		elseif player.putts < player.arrangedpar[player.holeCount]+10 then
			player.crawlScore = (GDEFSCORE + (multiplier*500)) + player.rings*10
		end
		--Special text changes
		if player.putts == 1 then 
			player.crawlText = "Hole in one!"
			player.scoreColor = V_YELLOWMAP
		elseif player.putts == 420 then 
			player.crawlText = "nice"
			player.scoreColor = V_GREENMAP
		elseif player.fixedScoring <= 1 then 
			player.crawlText = (parScoring[1] .. (2-player.fixedScoring))
			player.scoreColor = V_ORANGEMAP
		elseif player.fixedScoring >= 10 then 
			player.crawlText = (parScoring[10] .. (player.fixedScoring-9))
			player.scoreColor = V_YELLOWMAP
		else 
			player.crawlText = parScoring[player.fixedScoring]
			player.scoreColor = 0
		end
	end
	
	//Initializing level par formatting
	if player.arrangedpar == nil then 
		player.arrangedpar = {}
		if not mapheaderinfo[gamemap].par then
			CONS_Printf(player, "\x85 ERROR - Course par not set! Set your map's par in your level header")
			CONS_Printf(player, "\x85 using 'Lua.Par = x' or 'Lua.Par = x;y;z' depending on how many")
			CONS_Printf(player, "\x85 holes your golf course has.")
			table.insert(player.arrangedpar, 1)
		else
			for parN in (mapheaderinfo[gamemap].par .. ";"):gmatch("([^;]*);") do
				table.insert(player.arrangedpar, parN)
			end
		end
	end
	
	//Difficulty selection
	if player.cmd.buttons & BT_WEAPONNEXT and (not (player.pflags & PF_WPNDOWN)) and player.puttReady then
		if player.puttspd < 6 then player.puttspd = $+1 end
	elseif player.cmd.buttons & BT_WEAPONPREV and (not (player.pflags & PF_WPNDOWN)) and player.puttReady then
		if player.puttspd > 0 then player.puttspd = $-1 end
	end
	
	//Roll braking
	if player.mo.state == S_PLAY_ROLL and player.speed and P_IsObjectOnGround(player.mo) then	
		player.mo.momx = FixedMul($, 509*FRACUNIT/512)
		player.mo.momy = FixedMul($, 509*FRACUNIT/512)
	end
	
	//Hole handler goes here
	for FOF in player.mo.subsector.sector.ffloors() do
		if FOF.sector.special == 8192
		and P_InsideANonSolidFFloor(player.mo, FOF)
		and (player.mo.state ~= S_PLAY_DEAD)
		and (not player.doneWithFOF) then
			if mapHoles[player.holeCount] == nil then
				P_DoPlayerFinish(player)
				player.newX = player.spawnx
				player.newY = player.spawny
				player.newZ = player.spawnz
				player.newAngle = player.spawnangle
				if player.indivfinished == nil then
					pfinished = $+10
					player.indivfinished = true
				end
			else
				player.newX = mapHoles[player.holeCount][2]
				player.newY = mapHoles[player.holeCount][3]
				player.newZ = mapHoles[player.holeCount][4]
				player.newAngle = mapHoles[player.holeCount][5]
			end
			player.mo.flags = $ | MF_NOGRAVITY
			player.finishtimer = 3*TICRATE/2
			player.finished = true
			player.doneWithFOF = true
			player.targetZ = player.mo.z+(90*FRACUNIT)
			S_StartSound(player.mo, sfx_ideya)
			break
		end
	end
	
	//HUD course end text handling
	if player.finished and player.textCrawl >= 550 then
		player.textCrawl = -100
	end
	if player.textCrawl < 160 and not player.crawlHalfway then
		player.textCrawl = $+12
		if player.textCrawl >= 160 then player.crawlHalfway = true end
	elseif player.crawlHalfway then
		if player.crawlTimer == 2*TICRATE then
			player.textCrawl = $+30
			if player.textCrawl >= 550 then 
				player.crawlHalfway = false
				player.crawlTimer = 0
			end
		else
			player.crawlTimer = $+1
		end
	end
	
	//Level end handling and spin effect go here
	if player.finished then
		if (not mapheaderinfo[gamemap].carryshield) 
		or mapheaderinfo[gamemap].carryshield == "false" then
			P_RemoveShield(player)
		end
		player.mo.state = S_PLAY_SPRING
		player.pflags = $ | PF_GODMODE
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.momz = 0
		player.pflags = $ | PF_DIRECTIONCHAR
		player.drawangle = $+ANGLE_45
		if player.mo.z < player.targetZ then
			player.mo.z = $+2*FRACUNIT
		end
		//Fair warning: it's a mess down here.
		if player.finishtimer then
			player.finishtimer = $-1
			if not player.finishtimer then
				//Spawn star circle
				local angles = 8
				local angle = 0
				for i = 0, angles - 1 do
					angle = FixedAngle(360*FRACUNIT/angles)*i
					local star = P_SpawnMobjFromMobj(player.mo, 20*cos(angle), 20*sin(angle), player.height/2, MT_PUTTSTAR)
					star.ignore = true
					star.scalespeed = FRACUNIT/24
					star.destscale = 0
					star.momx = 4 * cos(angle)
					star.momy = 4 * sin(angle)
					star.color = player.mo.color
				end
				//Spawn afterimage
				P_SpawnGhostMobj(player.mo)
				player.mo.state = S_INVISIBLE
				player.finished = false
				//Now let's calculate that score
				if player.putts ~= 0 then 
					local multiplier = player.arrangedpar[player.holeCount] - player.putts
					if (player.putts == 1) or (player.putts < player.arrangedpar[player.holeCount]-10) then
						P_AddPlayerScore(player, GDEFSCORE*2)
					elseif player.putts < player.arrangedpar[player.holeCount]+10 then
						P_AddPlayerScore(player, GDEFSCORE + (multiplier*500))
					end
					P_AddPlayerScore(player, player.rings*10)
					player.rings = 0;
					player.fixedScore = player.score
					//Basically...you have 5k points given if you complete a stage with a
					//number of putts equal to the course par. Values UNDER the par will increase
					//your score by +500 for every putt under the par. Values OVER the par will
					//decrease that score by -500. A hole in one means guaranteed 10k points.
					//after all that stuff is dealt with, every ring you grabebd gives you +10 points
				end
				
				//And now we deal with the next hole
				player.putts = 0
				player.doneWithFOF = false
				player.flagplaced = false
				if player.holeCount < table.getn(player.arrangedpar) then
					player.holeCount = $+1
					player.warptimer = TICRATE
				else
					player.warptimer = 2*TICRATE
					player.holeCount = 1
				end
			end
		end
	end
	
	//Preventing spectator mode from erasing your score
	if not player.score and player.fixedScore then
		player.score = player.fixedScore
	end
	
	//And here is the post-warp special effect for arriving in a new course
	if player.warptimer then
		player.warptimer = $-1
		if not player.warptimer then
			P_TeleportMove(player.mo, player.newX, player.newY, player.newZ+1)
			player.pflags = $ & ~PF_GODMODE
			player.pflags = $ & ~PF_DIRECTIONCHAR
			player.mo.angle = player.newAngle
			player.mo.state = S_PLAY_STND
			player.mo.flags = $ & ~MF_NOGRAVITY
		end
	end
	
	//STAAAARRRRRRSSSS
	if player.puttReady then
		local fluctuate = {-2,-1,0,1,2,1,0,-1}
		local alternator = fluctuate[((leveltime%16)/2) + 1]
		if leveltime%2 == 0 then
			local star = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_GOLFSTAR)
			star.scale = 1
			star.scalespeed = FRACUNIT/48
			star.color = player.mo.color
			star.momx =	-4*cos(player.drawangle+(ANGLE_11hh/2)*alternator)
			star.momy = -4*sin(player.drawangle+(ANGLE_11hh/2)*alternator)
		end
		local arrow = P_SpawnMobjFromMobj(player.mo, 0, 0, player.height, MT_GOLFARROW)
		arrow.state = player.arrowstate
		if player ~= displayplayer then
			arrow.flags2 = $ | MF2_DONTDRAW -- add the flag
		else
			arrow.flags2 = $ & ~MF2_DONTDRAW -- remove it
		end
	end
	
	//canPutt handler + checkpoint flag handler
	//if player.speed == 0 and player.mo.momz...
	if FixedHypot(player.mo.momx - player.cmomx, player.mo.momy - player.cmomy) == 0 and player.mo.momz == 0 and gametype & gametype == gametype & GT_GOLF and (not player.flagplaced) then
		player.canPutt = true
		player.pflags = $ & ~PF_JUMPED
		player.usedShield = false
		//let's check if this place has any invalid parts. Which is to say,
		//we'll check if this isn't a hole. If it is, we ain't doing jack.
		local invalid = false
		for FOF in player.mo.subsector.sector.ffloors() do
			if ((FOF.sector.special == 8192 --stage end
			or (FOF.sector.special > 0 and FOF.sector.special < 9) --damage and death FOF specials
			or FOF.sector.special == 12 --space drowning
			or player.mo.subsector.sector.special == 8192 --same as above for sectors
			or (player.mo.subsector.sector.special > 0 and player.mo.subsector.sector.special < 9)
			or player.mo.subsector.sector.special == 12) 
			and player.mo.z <= player.mo.subsector.sector.floorheight+100*FRACUNIT) then
				invalid = true
			end
		end
		if not (P_IsObjectOnGround(player.mo)) then
			invalid = true
		end
		if not invalid then
			//Adding checkpoint position and creating a new checkpoint flag
			if player.myFlag and player.myFlag.valid then player.myFlag.state = S_NULL end
			local myFlag = P_SpawnMobjFromMobj(player.mo, 15*cos(player.mo.angle+ANGLE_225), 15*sin(player.mo.angle+ANGLE_225), player.height+20*FRACUNIT, MT_GOLFFLAG)
			S_StartSoundAtVolume(player.mo, sfx_kc5d, 50)
			myFlag.angle = player.mo.angle
			myFlag.color = player.mo.color
			myFlag.endZ = player.mo.z
			myFlag.owner = player
			player.myFlag = myFlag
			player.flagplaced = true
		end
	end
	
	//Power bar handling
	if player.puttReady then
		if not player.modifier then player.modifier = 1 end
		if player.pwrBarPos > 80 or player.pwrBarPos < 0 then
			player.modifier = $*-1
		end
		if player.pwrBarPos < 0 then player.pwrBarPos = 0 end
		if player.pwrBarPos > 80 then player.pwrBarPos = 80 end
		player.pwrBarPos = $+(player.modifier*player.puttspd)
	end
	
	//Setting the current tic's momentum and state to be used in the next tic
	player.prevMomx = player.mo.momx
	player.prevMomy = player.mo.momy
	player.prevMomz = player.mo.momz
	player.prevState = player.mo.state
	
end

local function moveBlocker()--there are more than just move blockers here but I'm too lazy to change this now
	if gametype ~= GT_GOLF then return end
	for player in players.iterate do
		if (not player.valid) or (player.mo == nil) then continue end
		
		//Catching the player's movement values to be used in manual charging
		if player.cmd.sidemove ~= 0 then
			player.manualMove = player.cmd.sidemove
		elseif player.cmd.forwardmove ~= 0 then
			player.manualMove = player.cmd.forwardmove
		else
			player.manualMove = 0
		end
		
		//Preventing "infinite roll"
		if player.mo.state == S_PLAY_ROLL and player.cmd.buttons & BT_USE and gametype == GT_GOLF and P_IsObjectOnGround(player.mo) then
			player.cmd.buttons = $ & ~BT_USE
		end
		
		//Reverting a player's putt state when jumping
		if (player.puttReady and player.jumptapping and player.brakeready) then
			player.puttReady = false
			if (not player.mo.standingslope) and P_IsObjectOnGround(player.mo) then
				player.mo.momz = 4*FRACUNIT
				player.mo.state = S_PLAY_SPRING
			elseif not P_IsObjectOnGround(player.mo) then
				player.mo.state = S_PLAY_STND
				player.mo.momx = $/4
				player.mo.momy = $/4
				player.mo.momz = $/4
			else
				player.mo.state = S_PLAY_STND
			end
			player.brakeready = false
			S_StopSoundByID(player.mo, sfx_frev)
			S_StartSound(player.mo, sfx_cdfm51)
		end
		
		//Toggle jump mode
		if player.puttReady and (player.custtapping or player.fwdtapping) and P_IsObjectOnGround(player.mo) then
			S_StartSoundAtVolume(player.mo, sfx_tink, 110, player)
			if player.arrowstate == S_POINT1 then
				player.arrowstate = S_POINT2
			else
				player.arrowstate = S_POINT1
			end
		end
		
		//Prevent forward / backwards movement entirely
		if (player.cmd.forwardmove or player.cmd.forwardmove < 0) then
			player.cmd.forwardmove = 0
		end
		
		//Prevent strafing unless spinning and on the ground
		if (player.cmd.sidemove or player.cmd.sidemove < 0)
		and (player.mo.state ~= S_PLAY_ROLL) 
		or not (P_IsObjectOnGround(player.mo)) then
			player.cmd.sidemove = 0
		end	
	end
end

local function uncurlPrevention()
	for player in players.iterate do
		if gametype ~= GT_GOLF then return end
		if (not player.mo) then continue end
		
		//This only exists to prevent the player from uncurling for one tic in the ground.
		if player.speed
		and player.mo.eflags & MFE_JUSTHITFLOOR
		and (player.panim == PA_IDLE
		or player.panim == PA_WALK
		or player.panim == PA_RUN) then
			player.mo.sprite2 = SPR2_ROLL
		end
		
		if player.speed
		and (player.panim == PA_WALK
		or player.panim == PA_RUN) then
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ | PF_SPINNING
		end
		
		//A small fix for a text crawl issue
		if player.pflags & PF_FINISHED and player.textCrawl >= 390 then
			player.stopCrawl = true
		end
	end
end

local function putt(player)
	if gametype ~= GT_GOLF then return false end
	if (not player.mo) then return false end

	//Enter regular putt mode
	if ( player.spintapping and (not player.puttReady) and player.canPutt 
	and (player.panim == PA_IDLE or player.panim == PA_EDGE)
	and gametype & gametype == gametype & GT_GOLF ) then
		player.arrowstate = S_POINT1
		player.mo.state = S_PLAY_FAUXDASH
		S_StartSound(player.mo, sfx_frev)
		player.puttReady = true
		player.pwrBarPos = 1
	//Putt!
	elseif player.spintapping and player.puttReady then
		if player.mo.friction ~= 59392 then player.mo.friction = 59392 end
		player.canPutt = false
		player.blinktimer = 45
		player.flagplaced = false
		S_StopSoundByID(player.mo, sfx_frev)
		S_StartSound(player.mo, sfx_phit)
		if not (player.pflags & PF_FINISHED) then player.putts = $+1 end
		local angles = 8
		local angle = 0
		for i = 0, angles - 1 do
			angle = FixedAngle(360*FRACUNIT/angles) * i
			local star = P_SpawnMobjFromMobj(player.mo, 90*cos(angle), 90*sin(angle), 0, MT_PUTTSTAR)
			star.color = player.mo.color
			star.scale = FRACUNIT/2

			star.chaseangle = ANGLE_45*i
			star.target = player.mo
		end
		player.puttReady = false
		player.pflags = $ | PF_SPINNING
		player.mo.state = S_PLAY_ROLL
		player.speed = 10*FRACUNIT
		if player.pwrBarPos > 7 then
			player.mo.momx = player.pwrBarPos*cos(player.mo.angle)
			player.mo.momy = player.pwrBarPos*sin(player.mo.angle)
		else
			player.mo.momx = 8*cos(player.mo.angle)
			player.mo.momy = 8*sin(player.mo.angle)
		end
		if player.arrowstate == S_POINT2 then
			player.mo.momx = FixedMul($, 5*FRACUNIT/16)
			player.mo.momy = FixedMul($, 5*FRACUNIT/16)
			P_SetObjectMomZ(player.mo, ((player.pwrBarPos/6)+7)*FRACUNIT)
		end
	end
	
	return true
end

addHook("PlayerThink", golfHandler)

addHook("PreThinkFrame", moveBlocker)

addHook("PostThinkFrame", uncurlPrevention)

addHook("SpinSpecial", putt)

addHook("PlayerSpawn", function(player)
	if not player.valid then return end
	if (not player.mo) and player.myFlag and player.myFlag.valid then
		P_TeleportMove(player.realmo, player.myFlag.x+15*cos(player.myFlag.angle+ANGLE_45), player.myFlag.y+15*sin(player.myFlag.angle+ANGLE_45), player.myFlag.z)
		player.realmo.angle = player.myFlag.angle
		local youare = P_SpawnMobjFromMobj(player.realmo, 0,0,0, MT_YOUARE)
		player.noBounce = true
		youare.owner = player
		return
	elseif (not player.mo) and not(player.myFlag) then
		return
	end
	if not player.spawnx then
		player.spawnx = player.mo.x
		player.spawny = player.mo.y
		player.spawnz = player.mo.z
		player.spawnangle = player.mo.angle
	end
	if player.mo.flags & MF_NOGRAVITY then player.mo.flags = $ & ~MF_NOGRAVITY end
	player.flagplaced = true --A spawning player doesn't really need a flag right?
	player.canPutt = true
	player.pflags = $ & ~PF_JUMPED
	player.usedShield = false
	if player.myFlag and player.myFlag.valid and player.myFlag.owner.name == player.name then
		P_TeleportMove(player.mo, player.myFlag.x+15*cos(player.myFlag.angle+ANGLE_45), player.myFlag.y+15*sin(player.myFlag.angle+ANGLE_45), player.myFlag.z)
		player.mo.angle = player.myFlag.angle
	end
	if player.warptimer and player.warptimer > 2*TICRATE then player.warptimer = 2 end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		//Oh I hate this
		if not (player.cmd.buttons & BT_USE) then
			player.spintapready = true
			player.spintapping = false
		elseif player.spintapready then
			player.spintapping = true
			player.spintapready = false
		else
			player.spintapping = false
		end
		
		if not (player.cmd.buttons & BT_JUMP) then
			player.jumptapready = true
			player.jumptapping = false
		elseif player.jumptapready then
			player.jumptapping = true
			player.jumptapready = false
		else
			player.jumptapping = false
		end
		
		if not (player.cmd.buttons & BT_CUSTOM1) then
			player.custtapready = true
			player.custtapping = false
		elseif player.custtapready then
			player.custtapping = true
			player.custtapready = false
		else
			player.custtapping = false
		end
		
		if not (player.cmd.buttons & BT_TOSSFLAG) then
			player.ftossready = true
			player.ftoss = false
		elseif player.ftossready then
			player.ftoss = true
			player.ftossready = false
		else
			player.ftoss = false
		end
		
		
		//Debug data
		//Uncomment to get some info when pressing custom 2
		
		//if player.ctap then
			//CONS_Printf(player, "----DEBUG DATA FOR " .. player.name .. "----")
			//CONS_Printf(player, player.name .. "'s hole counter: " .. player.holeCount)
			//CONS_Printf(player, player.name .. "'s putts: " .. player.putts)
			//if player.newX then CONS_Printf(player, player.name .. "'s X destination: " .. player.newX) end
			//if player.newY then CONS_Printf(player, player.name .. "'s Y destination: " .. player.newY) end
			//if player.newZ then CONS_Printf(player, player.name .. "'s Z destination: " .. player.newZ) end
			//CONS_Printf(player, player.name .. "'s X spawn: " .. player.spawnx)
			//CONS_Printf(player, player.name .. "'s Y spawn: " .. player.spawny)
			//CONS_Printf(player, player.name .. "'s Z spawn: " .. player.spawnz)
		//end
		
	end
end)

//Stuff to be done on level changes
addHook("MapChange", function(mapnum)
	hud.enable("rings")
	if gametype ~= GT_GOLF then return end
	pfinished = 0
	maptimer = 150*TICRATE
	startmaptimer = false 
	for player in players.iterate do
		//Restarting assorted player variables so nothing is carried over, causing errors.
		if player.warptimer then player.warptimer = nil end
		if player.puttReady then player.puttReady = false end
		player.indivfinished = nil
		player.cmenu = false
		player.menuint = 285
		player.menutime = 0
		player.fixedScore = 0
		player.holeCount = 1
		player.stopCrawl = false
		player.putts = 0
		player.finishtimer = 0
		player.finished = false
		player.doneWithFOF = false
		player.arrangedpar = nil
		player.crawlHalfway = false
		player.crawlTimer = 0
		player.textCrawl = 550
		if player and player.myFlag and player.myFlag.valid then
			player.myFlag = nil
			player.arrangedpar = nil
		end
		if player.spawnx then
			player.spawnx = nil
			player.spawny = nil
			player.spawnz = nil
			player.spawnangle = nil
		end
		if player.newX then
			player.newX = nil
			player.newY = nil
			player.newZ = nil
			player.newAngle = nil
		end
	end
end)

local function orgTableComp(tableA, tableB)
  if tableA[1] < tableB[1]
    return true
  end
end

//Stuff to be done as soon as the level starts
addHook("MapLoad", function(mapnum)
	if gametype ~= GT_GOLF then return end
	if not (mapHoles == {}) then mapHoles = {} end
	for player in players.iterate do
		if player.puttReady then player.puttReady = false end
	end
	pfinished = 0
	maptimer = 150*TICRATE
	startmaptimer = false
	for mapthing in mapthings.iterate do
		if mapthing.type == 3500 then
			local orgTable = {
			  mapthing.angle/360,
			  mapthing.x*FRACUNIT,
			  mapthing.y*FRACUNIT,
			  mapthing.mobj.z,
			  FixedAngle(mapthing.angle*FRACUNIT)
			}
			//the table is built like this:
			//orgTable = {order, x, y, z, angle}
			table.insert(mapHoles, orgTable)
		end
	end
	if mapHoles[2] ~= nil then
		table.sort(mapHoles, orgTableComp)
	end
end)

//Letting players damage enemies with a faux dash
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo.state == S_PLAY_FAUXDASH then return true end
end)

//Dealing with players being damaged while they charge
addHook("MobjDamage", function(p, inflictor, source, damage, damagetype)
	if not p.valid then return end
	if p.player.puttReady then p.player.puttReady = false end
end, MT_PLAYER)

//Dealing with suicidal tendencies and hole problems
addHook("MobjDeath", function(p, inflictor, source, damagetype)
	if not p.valid then return end
	if p.player.finished then
		p.player.finished = false
		p.state = S_DEATHSTATE
		p.player.doneWithFOF = false
		player.pflags = $ & ~PF_GODMODE
		if (p.player.warptimer) then p.player.warptimer = FRACUNIT end
	end
	if p.player.puttReady then p.player.puttReady = false end
end, MT_PLAYER)

//Bouncing players off walls
addHook("MobjMoveBlocked", function(p)
	if gametype ~= GT_GOLF then return end
	if p.state == S_PLAY_ROLL then
		//grounded version is a bit hacky, but it works I guess
		if P_IsObjectOnGround(p) then
			P_BounceMove(p)
			//Fix for "bounceless" ground collisions
			p.momx = $+(($/5)*4)
			p.momy = $+(($/5)*4)
		else
			P_BounceMove(p)
		end
		S_StartSoundAtVolume(p, sfx_s25a, 110)
	end
end, MT_PLAYER)

//Sync our holes list
addHook("NetVars", function(net)
	if gametype ~= GT_GOLF then return end
	mapHoles = net(mapHoles)
	pfinished = net(pfinished)
	startmaptimer = net(startmaptimer)
	maptimer = net(maptimer)
	d = net(d)
	m = net(m)
end)

//Absolutely killing any and all abilities for the sake of making sheilds work.
//Maybe one day I'll add per-character traits. don't count on it.
addHook("AbilitySpecial", function(p)
	if gametype ~= GT_GOLF then return end
	return true
end)
addHook("JumpSpinSpecial", function(p)
	if gametype ~= GT_GOLF then return end
	return true
end)
addHook("JumpSpecial", function(p)
	if gametype ~= GT_GOLF then return end
	return true
end)

//Making sure popped monitors and enemies don't send you flying due to hacky grounded bounces
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if gametype ~= GT_GOLF then return end
	if inflictor == nil then return end
	if inflictor.player 
	and P_IsObjectOnGround(inflictor) then
		inflictor.momx = $-($/4)
		inflictor.momy = $-($/4)
	end
	return
end)
addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if gametype ~= GT_GOLF then return end
	if inflictor == nil then return end
	if inflictor.player 
	and target.flags & MF_MONITOR
	and P_IsObjectOnGround(inflictor) then
		inflictor.momx = $-($/4)
		inflictor.momy = $-($/4)
	end
end)

//Specific shield handling
addHook("ShieldSpecial", function(p)
	if gametype ~= GT_GOLF then return end
	if p.usedShield == true then
		return true 
	end
	
	if p.powers[pw_shield] == 2
	or p.powers[pw_shield] == 1025
	or p.powers[pw_shield] == 3073
	or p.powers[pw_shield] == 4098 then
		p.usedShield = true
	end
	//Handler to counteract bouncing against thin air while using the force shield
	if p.powers[pw_shield] & SH_FORCE
		p.noBounce = true
		p.mo.state = S_PLAY_FALL
	end
	return false
end)

//Command for playerforexit-like tweaking
local function PlayersForGolfExit(player, arg)
	if player.mo and player.mo.valid and startmaptimer == false then
		if arg then
			arg = arg:lower()
			if arg == "1/4" then
				CONS_Printf(player, "The countdown will start after 1/4 players finish a map.")
				d = 4
				m = 1
			elseif arg == "1/2" then 
				CONS_Printf(player, "The countdown will start after 1/2 players finish a map.")
				d = 2
				m = 1
			elseif arg == "3/4" then
				CONS_Printf(player, "The countdown will start after 3/4 players finish a map.")
				d = 4
				m = 3
			elseif arg == "all" then 
				CONS_Printf(player, "The countdown has been disabled.")
				d = 1
				m = 1
			end
		else
			CONS_Printf(player, "Determines how many players need to complete a golf map")
			CONS_Printf(player, "before the map end timer begins. Set to 3/4 by default.")
			CONS_Printf(player, "")
			CONS_Printf(player, "Valid options: 'All', '3/4', '1/2', '1/4'")
		end
	else
		CONS_Printf(player, "This command will only work inside a level while the end timer is not running.")
	end
end

COM_AddCommand("playersforgolfexit", function(player, arg)
	PlayersForGolfExit(player, arg)
end, COM_ADMIN)

//Early level end timer after X players finish
addHook("ThinkFrame", function()
	playing = 0
	for player in players.iterate do
		playing = $+10
	end
	if pfinished == playing then 
		startmaptimer = false 
	end
	if startmaptimer and maptimer > 0 then
		maptimer = $-1
		if maptimer == 11*TICRATE then S_ChangeMusic("_DROWN", false) end
		if maptimer == 0 then
			for player in players.iterate do
				if player.indivfinished == nil then
					P_DoPlayerFinish(player)
					if player.mo and player.mo.valid then
						P_KillMobj(player.mo)
					end
				end
			end
		end
	end
    if pfinished >= (playing/d)*m and pfinished ~= 0 and startmaptimer == false and (pfinished ~= playing) then
		print("\x85 Enough players have finished the map!")
		print("\x85 Map end timer started.")
		startmaptimer = true
	end
end)